// Key.h: interface for the CKey class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_KEY_H__9D043055_C693_4F4F_BCD1_6E719E9291FE__INCLUDED_)
#define AFX_KEY_H__9D043055_C693_4F4F_BCD1_6E719E9291FE__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "TimLib.h"
#include <list>
#include <iterator>
#include <fstream>
#include <iostream>
#include <strstream>
#include <sstream>
using namespace std;
#include "Macrodef.h"
typedef list<tstring*>           t_stringList;
typedef list<tstring*>::iterator t_stringListIter;


class  CKey : public CTimLib  
{
public:
	virtual void PublicKeySize( unsigned int uiPublicKeySize ){m_uiPublicKeySize = uiPublicKeySize; }
	virtual void KeySize( unsigned int uiKeySize ){m_uiKeySize = uiKeySize; }

	virtual void ResetPrivateKey() = 0;
	virtual void DiscardAll() = 0;
	virtual bool FromKeyInfo_3_4( KEY_MOD_3_4_0& stKey ) = 0;
	virtual KEY_MOD_3_4_0 ToKeyInfo_3_4() = 0;
	virtual bool FromPlatDs( PLAT_DS& stDs ) = 0;
	virtual PLAT_DS toPlatDs() = 0;
	virtual bool PrivateFromArray( UINT* pPrivateAry, unsigned int size ) = 0;
	virtual bool PrivateToArray( UINT* pPrivateAry, unsigned int size ) = 0;
	virtual bool PubCompDFromArray( UINT* pCompDAry, unsigned int size ) = 0;
	virtual bool PubCompDToArray( UINT* pCompDAry, unsigned int size ) = 0;
	virtual bool PubCompEFromArray( UINT* pCompEAry, unsigned int size ) = 0;
	virtual bool PubCompEToArray( UINT* pCompEAry, unsigned int size ) = 0;

	virtual CKey* newCopy() = 0;

public:
	CKey(void);
	virtual ~CKey(void);

	// copy constructor
	CKey( const CKey& rhs );
	// assignment operator
	CKey& operator=( const CKey& rhs );

public:
	tstring& KeyId() { return m_sKeyId; }
	void KeyId( tstring& sKeyId );

	tstring& KeyTag() { return m_sKeyTag; }
	void KeyTag( tstring& sKeyTag );

	tstring& HashAlgorithmIdStr() { return m_sHashAlgorithmId; }
	void HashAlgorithmId( tstring& sHashAlgorithmId ){ m_sHashAlgorithmId = sHashAlgorithmId; m_bChanged = true; }
	void HashAlgorithmId( HASHALGORITHMID_T Id );
	HASHALGORITHMID_T HashAlgorithmId();

	tstring& EncryptAlgorithmIdStr() { return m_sEncryptAlgorithmId; }
	void EncryptAlgorithmId( tstring& sEncryptAlgorithmId ){ m_sEncryptAlgorithmId = sEncryptAlgorithmId; m_bChanged = true; }
	void EncryptAlgorithmId( ENCRYPTALGORITHMID_T Id );
	ENCRYPTALGORITHMID_T EncryptAlgorithmId();

	unsigned int ActiveSizeOfList( t_stringList& List );
	unsigned int& PublicKeySize(){ return m_uiPublicKeySize; }
	unsigned int& KeySize(){ return m_uiKeySize; }

	virtual bool IsChanged();
	virtual void Changed( bool bSet ){ m_bChanged = bSet; }

	virtual bool Encrypted() { return m_bEncrypted; }
	virtual void Encrypted( bool bEnc ){ m_bEncrypted = bEnc; }
protected:
	bool            m_bChanged;
	tstring			m_sEncryptAlgorithmId;
	tstring			m_sKeyId;
	tstring			m_sKeyTag;
	tstring			m_sHashAlgorithmId;

	unsigned int m_uiPublicKeySize;
	unsigned int m_uiKeySize;
	bool         m_bEncrypted;           // temp - do not store
};

typedef list<CKey*>           t_KeyList;
typedef list<CKey*>::iterator t_KeyListIter;


#endif // !defined(AFX_KEY_H__9D043055_C693_4F4F_BCD1_6E719E9291FE__INCLUDED_)
